/***************************************************************************

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

***************************************************************************/


#include <qcheckbox.h>
#include <qspinbox.h>
/**
	GUI
	wszystkie metody, ktre ustawiaj GUI
**/

void Waiting::createGUI(void)
{
// okrela na jakiej pozycji znajdzie si nowy element w menu kontekstowym
	PosInMenu = UserBox::userboxmenu->indexOf(UserBox::userboxmenu->getItem(tr("Offline to user"))); // szuka w menu "Niedostpny dla Kontaktu"
	if (PosInMenu == -1)		// jeli nie znalaz - przypisuje warto 7 - u mnie jest na takiej pozycji ;)
	{
		PosInMenu = 7;
		kdebugm(KDEBUG_WARNING, "szukanie pozycji w menu nie powiodo si - przyjmuj warto domyln...\n");
	}
	PosInMenu += 1;			// bo oszacowywa dla "Niedostpny dla..."
	
// dodaje nowy element w menu kontekstowym na licie kontaktw - na podstawie tego, co oszacowa
// nowa pozycja - po naciniciu wywoa wait4Person
	UserBox::userboxmenu->addItemAtPos(PosInMenu, "Wait4Person", tr("Wait for this person"), this, SLOT(wait4Person()));



// nowa zakadka
	ConfigDialog::addTab(QT_TRANSLATE_NOOP("@default", "Iwait4u"), "Iwait4u_tab");
	ConfigDialog::addLabel("Iwait4u", "Iwait4u", QT_TRANSLATE_NOOP("@default", "List of users, about which module should ALWAYS inform you."));
	ConfigDialog::addLabel("Iwait4u", "Iwait4u", QT_TRANSLATE_NOOP("@default", "They will be NEVER removed from the tracked list by computer."));
	ConfigDialog::addLabel("Iwait4u", "Iwait4u", QT_TRANSLATE_NOOP("@default", "You can remove them only here."));
	ConfigDialog::addLabel("Iwait4u", "Iwait4u", QT_TRANSLATE_NOOP("@default", "If you want to be informed only ONCE, use popup menu on users list in Kadu main window instead of this!"));
	ConfigDialog::addGrid("Iwait4u", "Iwait4u", "iwait4u_listboxy", 3);

		ConfigDialog::addGrid("Iwait4u", "iwait4u_listboxy", "iwait4u_listbox1", 1);
			ConfigDialog::addLabel("Iwait4u", "iwait4u_listbox1", QT_TRANSLATE_NOOP("@default", "All users:"));
			ConfigDialog::addListBox("Iwait4u", "iwait4u_listbox1","iwait4u_available");

		ConfigDialog::addGrid("Iwait4u", "iwait4u_listboxy", "iwait4u_listbox2", 1);
			ConfigDialog::addPushButton("Iwait4u", "iwait4u_listbox2", "", "AddToNotifyList","","iwait4u_forward");
			ConfigDialog::addPushButton("Iwait4u", "iwait4u_listbox2", "", "RemoveFromNotifyList","","iwait4u_back");

		ConfigDialog::addGrid("Iwait4u", "iwait4u_listboxy", "iwait4u_listbox3", 1);
			ConfigDialog::addLabel("Iwait4u", "iwait4u_listbox3", QT_TRANSLATE_NOOP("@default", "Always wait for:"));
			ConfigDialog::addListBox("Iwait4u", "iwait4u_listbox3", "iwait4u_track");

	ConfigDialog::connectSlot("Iwait4u", "", SIGNAL(clicked()), this, SLOT(_Right(void)), "iwait4u_forward");
	ConfigDialog::connectSlot("Iwait4u", "", SIGNAL(clicked()), this, SLOT(_Left(void)), "iwait4u_back");
	ConfigDialog::connectSlot("Iwait4u", "iwait4u_available", SIGNAL(doubleClicked(QListBoxItem *)), this, SLOT(_Right(void)));
	ConfigDialog::connectSlot("Iwait4u", "iwait4u_track", SIGNAL(doubleClicked(QListBoxItem *)), this, SLOT(_Left(void)));

// sounds:
	ConfigDialog::addVGroupBox("Iwait4u", "Iwait4u", QT_TRANSLATE_NOOP("@default", "iwait4u sounds"));
	ConfigDialog::addCheckBox("Iwait4u", "iwait4u sounds", QT_TRANSLATE_NOOP("@default", "Use both window and sound to inform"), "iwait4u_use_sounds", false);
	ConfigDialog::addCheckBox("Iwait4u", "iwait4u sounds", QT_TRANSLATE_NOOP("@default", "Repeat sounds (until OK pressed)"), "iwait4u_repeat_sounds", false);
	ConfigDialog::addSpinBox("Iwait4u", "iwait4u sounds", QT_TRANSLATE_NOOP("@default", "Time between repeating of sound (including length of sound!), in ms"), "iwait4u_sounds_delay", 10, 100000, 100, 3000);
	ConfigDialog::addLineEdit("Iwait4u", "iwait4u sounds", QT_TRANSLATE_NOOP("@default", "Path to sound:"), "iwait4u_sound_path", "", QT_TRANSLATE_NOOP("@default", ""));
	ConfigDialog::addPushButton("Iwait4u", "iwait4u sounds", QT_TRANSLATE_NOOP("@default","Choose path"));



	ConfigDialog::connectSlot("Iwait4u", QT_TRANSLATE_NOOP("@default", "Use both window and sound to inform"), SIGNAL(toggled(bool)), this, SLOT(changeUseSounds()));
	ConfigDialog::connectSlot("Iwait4u", QT_TRANSLATE_NOOP("@default", "Repeat sounds (until OK pressed)"), SIGNAL(toggled(bool)), this, SLOT(changeRepeatSounds()));
	ConfigDialog::connectSlot("Iwait4u", QT_TRANSLATE_NOOP("@default","Choose path"), SIGNAL(clicked()), this, SLOT(chooseSoundFile(void)));



	ConfigDialog::registerSlotOnCreate(this, SLOT(onCreateConfigDialog(void)));
	ConfigDialog::registerSlotOnApply(this, SLOT(onApplyConfigDialog(void)));
} 

void Waiting::destroyGUI(void)
{
	ConfigDialog::disconnectSlot("Iwait4u", "", SIGNAL(clicked()), this, SLOT(_Right(void)), "iwait4u_forward");
	ConfigDialog::disconnectSlot("Iwait4u", "", SIGNAL(clicked()), this, SLOT(_Left(void)), "iwait4u_back");
	ConfigDialog::disconnectSlot("Iwait4u", "iwait4u_available", SIGNAL(doubleClicked(QListBoxItem *)), this, SLOT(_Right(void)));
	ConfigDialog::disconnectSlot("Iwait4u", "iwait4u_track", SIGNAL(doubleClicked(QListBoxItem *)), this, SLOT(_Left(void)));
	ConfigDialog::disconnectSlot("Iwait4u", "Repeat sounds (until OK pressed)", SIGNAL(toggled(bool)), this, SLOT(changeRepeatSounds()));
	ConfigDialog::disconnectSlot("Iwait4u", "Use both window and sound to inform", SIGNAL(toggled(bool)), this, SLOT(changeUseSounds()));
	ConfigDialog::disconnectSlot("Iwait4u", "Choose path", SIGNAL(clicked()), this, SLOT(chooseSoundFile(void)));

	ConfigDialog::unregisterSlotOnCreate(this, SLOT(onCreateConfigDialog(void)));
	ConfigDialog::unregisterSlotOnApply(this, SLOT(onApplyConfigDialog(void)));

// sound
	ConfigDialog::removeControl("Iwait4u", "Path to sound:");
	ConfigDialog::removeControl("Iwait4u", "Choose path");
	ConfigDialog::removeControl("Iwait4u", "Time between repeating of sound (including length of sound!), in ms");
	ConfigDialog::removeControl("Iwait4u", "Repeat sounds (until OK pressed)");
	ConfigDialog::removeControl("Iwait4u", "Use both window and sound to inform");
	ConfigDialog::removeControl("Iwait4u", "iwait4u sounds");

// lista
	ConfigDialog::removeControl("Iwait4u", "iwait4u_track");
	ConfigDialog::removeControl("Iwait4u", "Always wait for:");
	ConfigDialog::removeControl("Iwait4u", "iwait4u_listbox3");
	ConfigDialog::removeControl("Iwait4u", "", "iwait4u_back");
	ConfigDialog::removeControl("Iwait4u", "", "iwait4u_forward");
	ConfigDialog::removeControl("Iwait4u", "iwait4u_listbox2");
	ConfigDialog::removeControl("Iwait4u", "iwait4u_available");
	ConfigDialog::removeControl("Iwait4u", "All users:");
	ConfigDialog::removeControl("Iwait4u", "iwait4u_listbox1");
	ConfigDialog::removeControl("Iwait4u", "iwait4u_listboxy");

	ConfigDialog::removeControl("Iwait4u", "If you want to be informed only ONCE, use popup menu on users list in Kadu main window instead of this!");
	ConfigDialog::removeControl("Iwait4u", "You can remove them only here.");
	ConfigDialog::removeControl("Iwait4u", "They will be NEVER removed from the tracked list by computer.");
	ConfigDialog::removeControl("Iwait4u", "List of users, about which module should ALWAYS inform you.");

	ConfigDialog::removeTab("Iwait4u");

// czyci menu kontekstowe	
	UserBox::userboxmenu->removeItem(PosInMenu);
}



/**
	konfiguracja
**/

void Waiting::onCreateConfigDialog(void)
{
	QListBox *e_availusers= ConfigDialog::getListBox("Iwait4u", "iwait4u_available");
	QListBox *e_notifies= ConfigDialog::getListBox("Iwait4u", "iwait4u_track");
	for (UserList::ConstIterator i = userlist.begin(); i != userlist.end(); ++i)
	{
		int uin = (*i).uin();
		if (!(uin == OurUin) && (*i).uin())	// jeli to nie jestemy my i nie jest user bez numeru
		{
			if (isAlwaysTracked((*i).uin()))
				e_notifies->insertItem((*i).altNick());
			else
				e_availusers->insertItem((*i).altNick());
		}
	}

	e_availusers->sort();
	e_notifies->sort();
	e_availusers->setSelectionMode(QListBox::Extended);
	e_notifies->setSelectionMode(QListBox::Extended);

	ConfigDialog::getSpinBox("Iwait4u", "Time between repeating of sound (including length of sound!), in ms")->setSuffix(" ms");
	
// sound
	ConfigDialog::getCheckBox("Iwait4u", "Repeat sounds (until OK pressed)")->setEnabled(UseSounds);
	ConfigDialog::getLineEdit("Iwait4u", "Path to sound:")->setEnabled(UseSounds);
	ConfigDialog::getPushButton("Iwait4u", "Choose path")->setEnabled(UseSounds);
	ConfigDialog::getSpinBox("Iwait4u", "Time between repeating of sound (including length of sound!), in ms")->setEnabled(UseSounds);
	if (!RepeatSounds)
		ConfigDialog::getSpinBox("Iwait4u", "Time between repeating of sound (including length of sound!), in ms")->setEnabled(RepeatSounds);
}

void Waiting::onApplyConfigDialog(void)
{
	unsigned int i;
	QListBox *e_notifies= ConfigDialog::getListBox("Iwait4u", "iwait4u_track");
	
// ALWAYS
	AlwaysTracked.clear();

	for (i = 0; i < e_notifies->count(); ++i)
	{
		int uin = userlist.byAltNick(e_notifies->text(i)).uin();
		AlwaysTracked.append(uin);
	}
		
	saveAlwaysTrackedList();

// sounds
	SoundPath = ConfigDialog::getLineEdit("Iwait4u", "Path to sound:")->text();
	TimeBetweenSounds = ConfigDialog::getSpinBox("Iwait4u", "Time between repeating of sound (including length of sound!), in ms")->value();
}

void Waiting::_Left(void)
{
	QListBox *e_availusers= ConfigDialog::getListBox("Iwait4u", "iwait4u_available");
	QListBox *e_notifies= ConfigDialog::getListBox("Iwait4u", "iwait4u_track");
	QStringList tomove;
	unsigned int i;

	for(i=0; i<e_notifies->count(); ++i)
		if (e_notifies->isSelected(i))
			tomove+=e_notifies->text(i);

	FOREACH(elem, tomove)
	{
		e_availusers->insertItem(*elem);
		e_notifies->removeItem(e_notifies->index(e_notifies->findItem(*elem)));
	}

	e_availusers->sort();
}

void Waiting::_Right(void)
{
	QListBox *e_availusers= ConfigDialog::getListBox("Iwait4u", "iwait4u_available");
	QListBox *e_notifies= ConfigDialog::getListBox("Iwait4u", "iwait4u_track");
	QStringList tomove;
	unsigned int i;

	for(i=0; i<e_availusers->count(); ++i)
		if (e_availusers->isSelected(i))
			tomove+=e_availusers->text(i);

	FOREACH(elem, tomove)
	{
		e_notifies->insertItem(*elem);
		e_availusers->removeItem(e_availusers->index(e_availusers->findItem(*elem)));
	}

	e_notifies->sort();
}

void Waiting::changeUseSounds(void)
{
	UseSounds=!UseSounds;
	ConfigDialog::getCheckBox("Iwait4u", "Repeat sounds (until OK pressed)")->setEnabled(UseSounds);
	ConfigDialog::getLineEdit("Iwait4u", "Path to sound:")->setEnabled(UseSounds);
	ConfigDialog::getPushButton("Iwait4u", "Choose path")->setEnabled(UseSounds);
	ConfigDialog::getSpinBox("Iwait4u", "Time between repeating of sound (including length of sound!), in ms")->setEnabled(UseSounds);
	if (!RepeatSounds)
		ConfigDialog::getSpinBox("Iwait4u", "Time between repeating of sound (including length of sound!), in ms")->setEnabled(RepeatSounds);
}

void Waiting::changeRepeatSounds(void)
{
	RepeatSounds=!RepeatSounds;
	ConfigDialog::getSpinBox("Iwait4u", "Time between repeating of sound (including length of sound!), in ms")->setEnabled(RepeatSounds);
}

void Waiting::chooseSoundFile(void)
{
	QString start=QDir::rootDirPath();
	QString p=ConfigDialog::getLineEdit("Iwait4u", "Path to sound:")->text();

	if (QFile(p).exists())
		start=p;
	
	QString s(QFileDialog::getOpenFileName( start, "Audio Files (*.wav *.au *.raw)", ConfigDialog::configdialog));
	if (s.length())
		ConfigDialog::getLineEdit("Iwait4u", "Path to sound:")->setText(s);
}


/**
	inne
**/

void Waiting::popupMenu()
{
	UserList users;
	UserBox *activeUserBox = UserBox::getActiveUserBox();
	if (activeUserBox == NULL)
	{
		return;
	}
	users = activeUserBox->getSelectedUsers();
	
	// Jeeli to jestemy my lub to jest kontakt SMS (bez numerka GG) - szary
	if (users.containsUin(OurUin) || users.containsUin(0))	// uin 0 ma osoba bez numeru
		UserBox::userboxmenu->setItemEnabled(PosInMenu, false);


	for (UserList::ConstIterator i = users.begin(); i != users.end(); ++i)
	{	// jeli user jest na licie ALWAYS - szary + chackbox
		if (isAlwaysTracked((*i).uin()))
		{
			UserBox::userboxmenu->setItemEnabled(PosInMenu, false);
			UserBox::userboxmenu->setItemChecked(PosInMenu, true);
			break;				// przerywa jeli ju znalaz jednego
		} else if (isOnTrackedList((*i).uin()))	// jeli uin jest na licie poszukiwanych - zaznacza checkbox.
		{
			UserBox::userboxmenu->setItemChecked(PosInMenu, true);
			// nie przerywa, bo jeli osoba z Tracked bya przed always, to nie zrobiby szarego
		}
	}
}
